void UserContactRestitution11 (const NewtonJoint* contactJoint, dFloat timestep, int threadIndex)
{
	dFloat Ixx;
	dFloat Iyy;
	dFloat Izz;
	dFloat mass;
	
	const NewtonBody* body;
	const NewtonBody* body0;
	const NewtonBody* body1;

	GenericContactProcess (contactJoint, timestep, threadIndex);

	body0 = NewtonJointGetBody0(contactJoint);
	body1 = NewtonJointGetBody1(contactJoint);

	body = body0;
	NewtonBodyGetMassMatrix (body, &mass, &Ixx, &Iyy, &Izz);
	if (mass == (float)0.0) {
		body = body1;
	}
	
	void* contact;
	for (contact = NewtonContactJointGetFirstContact (contactJoint); contact; contact = NewtonContactJointGetNextContact (contactJoint, contact)) {
		NewtonMaterial* nmaterial;
		nmaterial = NewtonContactGetMaterial (contact);
		
		you = (ENTITY*)NewtonBodyGetUserData(body);
		
		NewtonMaterialSetContactElasticity (nmaterial, (float)you.skill98);
	}
	
	ShowContacts (contactJoint);
}

action ball_gen_11_newt()
{
	wait(3);
	set(my,INVISIBLE);
	
	NewtonMaterialSetCollisionCallback (nworld, defaultID, defaultID, NULL, NULL, UserContactRestitution11); 
	
	// creating balls
	int i;
	NewtonBody* temp_body;
	for(i = 0;i < 6; i++)
	{
		you = ent_create("ball.mdl",vector(my.x,my.y+45*i,my.z),0);
		vec_set(you.scale_x,my.scale_x);
		temp_body = newton_addentity(you, 25, NEWTON_SPHERE, onforceandtorque);
		NewtonBodySetLinearDamping (temp_body, (float)0.0);
		you.skill98 = 0.1 + i * .1;
	}
}