#define sID					skill75

#define BoxID		1


var grab_pos[3];
var grabbed;

ENTITY* temp_ent;
NewtonBody* body_throw;


var grab_force[3];
var force_jump;


void Grenadeforceandtorque(NewtonBody* body);
void scan_grenade();

void fireentity()
{
	var power = 0;
	while(mouse_left) // power depends on how long you hold the mouse button
	{
		power = clamp(power + time_step, 10, 30);
		draw_line(vector(10, 40, 0), 0, 100);
		draw_line(vector(10, 40, 0), vector(255,255,255), 100);
		draw_line(vector(10 + power * 5, 40, 0), vector(255,255,255), 100);
		wait(1);	
	}
	
	VECTOR v;
	//	vec_set(&v, vector(-10, 0, 0));
	//	vec_rotate(&v, &camera->pan);
	vec_set(&v, &camera->x);
	if (grabbed && body_throw!=NULL)
	{
		vec_set(&v, vector(power, 0, 0));
		vec_rotate(&v, &camera->pan);
		NewtonBodySetVelocity(body_throw, vectorf(&v));
		grabbed=0;
	}
}


void calculate_grab_pos()
{
	while(1)
	{
		vec_set(grab_pos, vector(100, 0, 0));
		vec_rotate(grab_pos, camera.pan);
		vec_add(grab_pos, camera.x);
		wait(1);
	}
}

void grab_ent()//grabbs an entity
{	
	var trace_dir[3];
	float body_force[3];
	var grab_ent_force;
	var old_force;
	
	//	set(CamEnt,PASSABLE);  
	c_trace(camera.x, grab_pos,IGNORE_ME|IGNORE_PASSABLE|IGNORE_PASSENTS);
	//	reset(CamEnt,PASSABLE);  
	if (you!=NULL)
	{
		if(you.sID!=BoxID)//can't be grabbed?
		{
			return;//exit function
		}
	}
	else//no entity hit?
	{
		return;//exit function
	}
	
	temp_ent = you;//select that body
	body_throw = you.skill99;
	
	grabbed=1;//some entity is grabbed
	
	while(key_q)//wait while mouse is pressed
	{
		if(grabbed==0){return;}
		wait(1);
	}
	
	force_jump=0;
	
	var done_grab = 0;
	float body_mass;
	float dummy;
	
	while(grabbed)//grab loop
	{		
		NewtonBodySetOmega(body_throw,nullvector);//reset angular speed
		NewtonBodySetVelocity(body_throw, nullvector);//reset speed
		
		if(key_q){grabbed=0;}//mouse pressed again? - exit
		
		vec_set(grab_force,grab_pos);//calculate grab force
		vec_sub(grab_force,temp_ent.x);
		if(vec_dist(grab_pos,temp_ent.x)<2){done_grab=1;}
		
		NewtonBodyGetForce(body_throw, body_force);//get force applied to the entity
		grab_ent_force = body_force[0] + body_force[1] + body_force[2];//sum all forces
		force_jump = abs(grab_ent_force-old_force);//calculate force change
		old_force = grab_ent_force;//save current_force
		NewtonBodyGetMassMatrix(body_throw,body_mass,dummy,dummy,dummy);//get body mass
		
		if(done_grab&&force_jump>=40*body_mass)//force changes too strong(probably body is stuck)? - exit
		{
			NewtonBodySetOmega(body_throw,nullvector);//reset angular speed
			NewtonBodySetVelocity(body_throw, nullvector);//reset speed
			grabbed=0;//exit grab loop
		}
		
		//	NewtonWorldUnfreezeBody(nworld, body_throw);//activate body
		NewtonBodySetOmega(body_throw,nullvector);//reset angular speed
		NewtonBodySetVelocity(body_throw, vectorf(grab_force[0],grab_force[1],grab_force[2]));// move towards grab position
		wait(1);
	}
	/* */
}

action newt_15_start()
{
	on_mouse_left = fireentity;
	on_e = grab_ent;
	calculate_grab_pos();
}


action ball_15_newt()
{
	my.sID=BoxID;
	wait(3);
	newton_addentity(me, (float)75, NEWTON_SPHERE, onforceandtorque);
}

action box_15_newt()
{
	my.sID=BoxID;
	wait(3);
	newton_addentity(me, (float)75, NEWTON_BOX, onforceandtorque);
}

action cone_15_newt()
{
	my.sID=BoxID;
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CONE, onforceandtorque);
}

action caps_15_newt()
{
	my.sID=BoxID;
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CAPSULE, onforceandtorque);
}

action cyln_15_newt()
{
	my.sID=BoxID;
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CYLINDER, onforceandtorque);
}

action chcl_15_newt()
{
	my.sID=BoxID;
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CHAMFEREDCYLINDER, onforceandtorque);
}

action conv_15_newt()
{
	my.sID=BoxID;
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CONVEXHULL, onforceandtorque);
}