BMAP* arrow = "arrow.pcx";

var mouse_vec[3];
var tempr_vec[3];
var target_vec[3];
var normal_vec[3];
var old_pan_vec[3];
var old_pos_vec[3];
var diff_pos_vec[3];
var diff_pan_vec[3];

NewtonBody* body_temp;
ENTITY* selected_ent;

function mouse_init()
{
	selected_ent=NULL;
	mouse_range = 2000;
}

function mouse_toggle()
{  
	mouse_map = arrow;
	if (mouse_mode >= 2) {
		mouse_mode = 0;
		} else {
		mouse_mode = 2; 
	} 
	while (mouse_mode > 0) // move it over the screen
	{  
		vec_set(mouse_pos,mouse_cursor);
		wait(1);
	}
}

function mouse_click()
{	
	while (mouse_left)
	{		
		if (selected_ent==NULL)
		{
			// select entity
			vec_set (mouse_vec, mouse_dir3d); 
			vec_normalize(mouse_vec, 4000);
			vec_add (mouse_vec, camera.x);
			
			c_trace (camera.x, mouse_vec, IGNORE_ME|IGNORE_PASSABLE);
			
			vec_set(target_vec,target);
			vec_set(normal_vec,normal);
			
			vec_set(old_pan_vec,you.pan);
			vec_set(old_pos_vec,you.x);
			
			selected_ent=you;
			wait(1);
			//draw_point3d(selected_ent.x,vector(0,255,0),100,150);
		}
		if (selected_ent!=NULL)
		{
			
			//			// normal point of body
//			vec_diff(diff_pan_vec,old_pan_vec,selected_ent.pan);	// diff between old and new pan
//			vec_rotate(normal_vec,diff_pan_vec);						// rotate normal vec

			
			// target point of body
			
			vec_diff(diff_pos_vec,selected_ent.x,old_pos_vec); // diff between old and new pos
		//	vec_sub(target_vec,selected_ent.x);						// get vector from center to target point
			
		//	vec_set(diff_pan_vec,vec_to_angle(old_pan_vec,selected_ent.pan));	// get the angle between old and new pan
		//	ang_add(target_vec,diff_pan_vec);						// add this angle to target vec, while target_vec shows direction from center to point
			
			vec_add(target_vec,diff_pos_vec);						// add diff to target point
		//	vec_add(target_vec,selected_ent.x);						// add center
			
			vec_set(old_pan_vec,selected_ent.pan);					// update old pan			
			vec_set(old_pos_vec,selected_ent.x);					// update old pos
			
			
			
		//	draw_point3d(old_pos_vec,vector(0,255,0),100,3);
			//	
			
			// show target point and normal
			draw_line3d(target_vec,NULL,100);
			draw_line3d(target_vec,vector(0,255,0),100);	
			
			// normal
			
			draw_point3d(target_vec,vector(0,255,0),100,3);
			vec_set(mouse_vec,target_vec);
			vec_normalize(normal_vec,30);
			vec_add(mouse_vec,normal_vec);
			draw_line3d(mouse_vec,vector(0,0,255),100);
			
			
			// would change
		//	vec_set(target_vec,selected_ent.x);
			
			// to mouse
			draw_line3d(target_vec,NULL,100);
			draw_line3d(target_vec,vector(0,255,0),100);
			
			vec_set (mouse_vec, mouse_dir3d); 
			vec_normalize(mouse_vec, 4000);
			vec_add (mouse_vec, camera.x);
			
			c_trace (camera.x, mouse_vec, IGNORE_ME);
			
			draw_line3d(target,vector(255,0,0),100);	
		//	draw_point3d(target,vector(255,0,0),100,3);
			
			vec_diff(tempr_vec,target,target_vec);
			vec_scale(tempr_vec,QUANTTOMETER);
			
			if (selected_ent.skill99!=0)
			{
				body_temp=selected_ent.skill99;
				
				NewtonBodySetAutoFreeze (body_temp, 0);
				
				NewtonBodySetVelocity(body_temp, vectorf(tempr_vec[0], tempr_vec[1], tempr_vec[2]));
				
				NewtonBodySetAutoFreeze (body_temp, 1);
			}
		}
		wait(1);
	}
	selected_ent=NULL;
}




				//	vec_scale(temp_vec2,2);
				//	NewtonBodySetOmega(body_temp, vectorf(tempr_vec.x, tempr_vec.y, tempr_vec.z));
				
				
				
				//					if (c_trace(temp_vec.x, temp_vec2.x,IGNORE_ME|IGNORE_PASSABLE|IGNORE_PASSENTS) > 0) //|SCAN_TEXTURE
				//				{					
					//					if (you.sNBody!=0)
					//					{
						//						body_temp=you.sNBody;
						//						
						//						vec_set(temp_vec,target.x);
						//						vec_scale(temp_vec,QUANTTOMETER);
						//						
						//						vec_set(temp_vec2.x,vector(-normal.x,-normal.y,-normal.z));
						//						vec_normalize(temp_vec2.x,3);
						//						
						//						NewtonAddBodyImpulse(body_temp, vectorf(temp_vec2.x,temp_vec2.y,temp_vec2.z), vectorf(temp_vec.x, temp_vec.y, temp_vec.z));					
						//						//NewtonBodyAddImpulse
				// }}





/*
function mouse_click()
{	
	while (mouse_left)
	{
		// select entity
		vec_set (mouse_vec, mouse_dir3d); 
		vec_normalize(mouse_vec, 4000);
		vec_add (mouse_vec, camera.x); 
		
		c_trace (camera.x, mouse_vec, IGNORE_ME|IGNORE_PASSABLE);
		
		if (selected==NULL)
		{			
			vec_set(target_ent_vec,target);
			vec_set(normal_ent_vec,normal);
			
			vec_set(tempr_vec,target_vec);
			vec_normalize(normal_ent_vec,30);
			vec_add(tempr_vec,normal_ent_vec);
			
			selected=you;
		}
		if (selected!=NULL)
		{
			// show target point and normal
			draw_line3d(target_ent_vec,NULL,100);
			draw_line3d(target_ent_vec,vector(0,255,0),100);	
			
			// normal
			draw_point3d(target_ent_vec,vector(0,255,0),100,3);
			draw_line3d(tempr_vec,vector(0,0,255),100);
			
			// to mouse
			draw_line3d(target_ent_vec,NULL,100);
			draw_line3d(target_ent_vec,vector(0,255,0),100);
			
			draw_line3d(target,vector(255,0,0),100);			
		}
		wait(1);
	}
	selected=NULL;
}
*/