void scan_grenade()
{
	if ((event_type == EVENT_SCAN) && (you.sExplR!=0))
	{
		wait(random(50)+20);
		my.sHP=-10;
	}
}

void Grenadeforceandtorque(NewtonBody* body)
{	
	NewtonBodySetForce(body, vectorf(0, 0, -9.8 * 15));
	my = (ENTITY*)NewtonBodyGetUserData(body);
	my.sHP-=time_step;
	
	if (my.sHP <=0)
	{
		c_scan(my.x, vector(0,0,0), vector(360, 180, my.sExplR), IGNORE_ME);
		effect(effect_flame, 100, my.x, normal);
		
		NewtonDestroyBody(nworld,(NewtonBody*) my.skill99);
	}
}

var sTimeToCharge;

action ball_17_newt()
{
	VECTOR* temp_vec,temp_vec2;
	reset(my,VISIBLE);
	while(me)
	{
		vec_set(my.x,vector(camera.x,camera.y,camera.z+10));
		if (mouse_left && sTimeToCharge<=0) 
		{
			you = ent_create("level\\ball.mdl",camera.x,NULL);
			you.scale_x=.25; you.scale_y=.25; you.scale_z=.25;
			you.sHP=50;		// time to blow
			you.sExplR=300;		// range
			you.event=scan_grenade;
			c_setminmax(you);
			body_temp = newton_addentity(you, 20, NEWTON_SPHERE, Grenadeforceandtorque);
			NewtonBodySetContinuousCollisionMode(body_temp, 1);
			vec_set(temp_vec, vector(10, 0, 0));
			vec_rotate(temp_vec, camera.pan);
			NewtonBodySetVelocity(body_temp, vectorf(temp_vec.x, temp_vec.y, temp_vec.z));
			
			sTimeToCharge=20;
		}
		
		if (sTimeToCharge>0) {sTimeToCharge-=time_step; }
		wait(1);
	}
}

action box_17_newt()
{
	wait(3);
	newton_addentity(me, (float)75, NEWTON_BOX, onforceandtorque);
	EnableExplosion(me,.1);
}

action cone_17_newt()
{
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CONE, onforceandtorque);
	EnableExplosion(me,5);
}

action caps_17_newt()
{
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CAPSULE, onforceandtorque);
	EnableExplosion(me,2);
}

action cyln_17_newt()
{
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CYLINDER, onforceandtorque);
	EnableExplosion(me,.5);
}

action chcl_17_newt()
{
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CHAMFEREDCYLINDER, onforceandtorque);
	EnableExplosion(me,.2);
}

action conv_17_newt()
{
	wait(3);
	newton_addentity(me, (float)75, NEWTON_CONVEXHULL, onforceandtorque);
	EnableExplosion(me,1);
}
